'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAccordionItem = require('@mapbox/react-accordion-item');

var _reactAccordionItem2 = _interopRequireDefault(_reactAccordionItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ControlledAccordion = function (_React$PureComponent) {
  _inherits(ControlledAccordion, _React$PureComponent);

  function ControlledAccordion() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ControlledAccordion);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ControlledAccordion.__proto__ || Object.getPrototypeOf(ControlledAccordion)).call.apply(_ref, [this].concat(args))), _this), _this.onToggle = function (id) {
      var onToggle = _this.props.onToggle;

      onToggle(id);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }
  // If you change propTypes, also change propNames.


  _createClass(ControlledAccordion, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          items = _props.items,
          themeItem = _props.themeItem,
          themeItemHeader = _props.themeItemHeader,
          themeItemBody = _props.themeItemBody;


      var renderItems = function renderItems(item) {
        return _react2.default.createElement(_reactAccordionItem2.default, _extends({}, item, {
          key: item.id,
          active: item.id === _this2.props.activeItem,
          onToggle: _this2.onToggle,
          themeItem: themeItem,
          themeItemHeader: themeItemHeader,
          themeItemBody: themeItemBody
        }));
      };

      return _react2.default.createElement(
        'div',
        null,
        items.map(renderItems)
      );
    }
  }]);

  return ControlledAccordion;
}(_react2.default.PureComponent);

ControlledAccordion.propTypes = {
  items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    /** Identifying value for accordion item. */
    id: _propTypes2.default.string.isRequired,
    /** Contents that are always shown. */
    header: _propTypes2.default.func.isRequired,
    /** Contents that shown when the accordion is active. */
    body: _propTypes2.default.node.isRequired,
    /** Flag to disable the clickability of an accordion item. */
    disabled: _propTypes2.default.bool
  })).isRequired,
  /** Callback when an accordion header item is clicked. */
  onToggle: _propTypes2.default.func.isRequired,
  /** Value should coorespond to an `id` within the items array. */
  activeItem: _propTypes2.default.string,
  /** CSS classes to apply to the accordion item container */
  themeItem: _propTypes2.default.string,
  /** CSS classes to apply to the accordion header */
  themeItemHeader: _propTypes2.default.string,
  /** CSS classes to apply to the accordion body */
  themeItemBody: _propTypes2.default.string
};
exports.default = ControlledAccordion;